<?php 
/*
 * Database Updater module for Allmice™ CMS
 * Version 1.2.2 (2019-07-17)
 * Copyright 2019 by Any Outline LTD
 * http://www.allmice.com/cms
 * Database Updater module for Allmice CMS is released under the "GNU GENERAL PUBLIC LICENSE".
 * See LICENSE.TXT file in Allmice CMS Database Updater module root directory for more details about the license.
 */
 ?>

<?php

include $pathCoreController."Controller.php";
include $pathCoreModel."Form.php";
include $pathCoreModel."Paginator.php";

include $pathModuleModel."UpdaterForm.php";
include "core/includes/Model/"."DatabaseCms.php";
include $pathModuleModel."AppDatabase.php";
include $pathModuleModel."Updater.php";

class DatabaseUpdaterController extends Controller
{

	public $dbConfig;
	public $modConfig;
	public $modLang;

	public function indexEvent()
	{

		$output="";

		return array(
			'output' => $output,
		);

	}

	public function updateTablesStructureEvent()
	{

		$form = new UpdaterForm();
		$form->setUrl($GLOBALS['curUrl']);

		$updater = new Updater();
		$pgStatus="stage1";

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$newTableList=array();
		$oldTableList=array();
		$difItemList=array();

		$allDifList=array();
		$chDifList=array();
		$otherDifList=array();

		if (isset($_POST['submit1']) || isset($_POST['submit2'])) {

			$form->updateForm();
			$form->validation($appDb->getValidityPatterns($GLOBALS['modName']),array());

			if ($form->isValid) {

				if (isset($_POST['submit1'])) {
					$pgStatus="stage2";
				}
				elseif (isset($_POST['submit2'])) {
					$pgStatus="stage3";
				}
	
				$formData=$form->getData();
				$updater->convertFormData($formData);

				$newDbAccessData=$Database['app_db'];
				$newDbAccessData['dbName']=$updater->newDbName;
				$newDbAccessData['tablePrefix']=$updater->newDbTbPrefix;
				$oldDbAccessData=$Database['app_db'];
				$oldDbAccessData['dbName']=$updater->oldDbName;
				$oldDbAccessData['tablePrefix']=$updater->oldDbTbPrefix;
	
				try {
					$newDb = new AppDatabase($newDbAccessData);
					$newDbTbList=$newDb->getListOfTables($updater->newDbName,$updater->newDbTbPrefix);
				} catch (Exception $e) {
					echo "Database user may not have access right to database ",$updater->newDbName;
					echo "<br>";
				}
				try {
					$oldDb = new AppDatabase($oldDbAccessData);
					$oldDbTbList=$oldDb->getListOfTables($updater->oldDbName,$updater->oldDbTbPrefix);
				} catch (Exception $e) {
					echo "Database user may not have access right to database ",$updater->oldDbName;
					echo "<br>";
				}
	
				$difItem=array();
	
				foreach ($newDbTbList as $tableName) {
	//Iterate tables to find differences in field structures
					if(in_array($tableName,$oldDbTbList)){
	
						$oldDbStruct=$oldDb->getTableStruct($updater->oldDbTbPrefix, $tableName);
						$newDbStruct=$newDb->getTableStruct($updater->newDbTbPrefix, $tableName);
	
						if($oldDbStruct !== $newDbStruct){
	//Diffrence in field structures was found

							$allDifList[]=$tableName;

							for ($i=0;$i<count($newDbStruct);$i++) {
								$fieldNameStatus="notFound";
	//Iterate field structures of every different new table
	
	//There may be new fields
	
								for ($j=0;$j<count($oldDbStruct);$j++) {
		
									if($newDbStruct[$i]['Field'] == $oldDbStruct[$j]['Field']){
										$fieldNameStatus="found";
	
										if($newDbStruct[$i] !== $oldDbStruct[$j]){

											if(!in_array($tableName,$chDifList))
												$chDifList[]=$tableName;

											$difItem['tbName']=$tableName;
											$difItem['fldName']=$oldDbStruct[$j]['Field'];
											$difItem['oldStruct']=$oldDbStruct[$j];
											$difItem['newStruct']=$newDbStruct[$i];
	
											$difItemList[]=$difItem;

											if ($pgStatus=="stage3") {
												$oldDb->changeStructure($newDbStruct[$i], $oldDbStruct[$j], $updater->oldDbTbPrefix, $tableName);
											}
	
										}
									}
								}
							}
	
						}
					}else{
//Collect new tables, which are missing in old db. table list

						$newTableList[]=$tableName;
					}
				}

				foreach ($oldDbTbList as $tableName2) {
//Find old tables, which are missing in new db. table list
					if(in_array($tableName2,$newDbTbList)){
					}else{
//Collect old tables, which are missing in new db. table list
						$oldTableList[]=$tableName2;
					}
				}

				foreach ($allDifList as $tableName3) {
//Find other tables, which structures have differences between the two db. versions
					if(in_array($tableName3,$chDifList)){
					}else{
//Collect other tables tables
						$otherDifList[]=$tableName3;
					}
				}

			}
			else{
				$form->setErrorMessages();

			}

		}

		return array(
			'newTableList' => $newTableList,
			'oldTableList' => $oldTableList,
			'difItemList' => $difItemList,
			'otherDifList' => $otherDifList,
			'pgStatus' => $pgStatus,
			'form' => $form,
		);

	}


	public function updateMissingEntriesEvent()
	{

		$form = new UpdaterForm();
		$form->setUrl($GLOBALS['curUrl']);
		$form->formMap['submit1']['value']="Find missing entries";
		$form->formMap['submit2']['value']="Add missing entries";

		$updater = new Updater();
		$pgStatus="stage1";

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$newTableList=array();
		$oldTableList=array();
		$difItemList=array();

		$allDifList=array();
		$chDifList=array();
		$otherDifList=array();
		$oldDbMissingList=array();

		if (isset($_POST['submit1']) || isset($_POST['submit2'])) {

			$form->updateForm();
			$form->validation($appDb->getValidityPatterns($GLOBALS['modName']),array());

			if ($form->isValid) {

				if (isset($_POST['submit1'])) {
					$pgStatus="stage2";
				}
				elseif (isset($_POST['submit2'])) {
					$pgStatus="stage3";
				}
	
				$formData=$form->getData();
				$updater->convertFormData($formData);

				$newDbAccessData=$Database['app_db'];
				$newDbAccessData['dbName']=$updater->newDbName;
				$newDbAccessData['tablePrefix']=$updater->newDbTbPrefix;
				$oldDbAccessData=$Database['app_db'];
				$oldDbAccessData['dbName']=$updater->oldDbName;
				$oldDbAccessData['tablePrefix']=$updater->oldDbTbPrefix;
	
				try {
					$newDb = new AppDatabase($newDbAccessData);
					$inputFldList=array("module_name","uri","type");
					$tbName="core_config";
					$newDbEntryList['config']=$newDb->getListOfEntries($updater->newDbTbPrefix,$tbName,$inputFldList);
	
					$tbName="core_language";
					$inputFldList=array("module_name","uri","type","specific_name","language_code");
					$newDbEntryList['lang']=$newDb->getListOfEntries($updater->newDbTbPrefix,$tbName,$inputFldList);
	
					$tbName="core_misc_data";
					$inputFldList=array("module_name","uri","type");
					$newDbEntryList['misc']=$newDb->getListOfEntries($updater->newDbTbPrefix,$tbName,$inputFldList);
	
				} catch (Exception $e) {
					echo "Database user may not have access right to database ",$updater->newDbName;
					echo "<br>";
				}
				try {
	
					$oldDb = new AppDatabase($oldDbAccessData);
	
					$tbName="core_config";
					$newList=$newDbEntryList['config'];
					$inputFldList=array("module_name","uri","type");
					$outputFldList=array("description","value");
					$oldDbMissingList['config']=$oldDb->getMissingEntries($updater->oldDbTbPrefix,$tbName,$newList,$inputFldList,$outputFldList);
	
					$tbName="core_language";
					$newList=$newDbEntryList['lang'];
					$inputFldList=array("module_name","uri","type","specific_name","language_code");
					$outputFldList=array("text");
					$oldDbMissingList['lang']=$oldDb->getMissingEntries($updater->oldDbTbPrefix,$tbName,$newList,$inputFldList,$outputFldList);
	
					$tbName="core_misc_data";
					$newList=$newDbEntryList['misc'];
					$inputFldList=array("module_name","uri","type");
					$outputFldList=array("integer_value","value");
					$oldDbMissingList['misc']=$oldDb->getMissingEntries($updater->oldDbTbPrefix,$tbName,$newList,$inputFldList,$outputFldList);
	
					if ($pgStatus=="stage3") {
	
						$tablePrefix=$updater->oldDbTbPrefix;
	
						$missingEntryList=$oldDbMissingList['config'];
						$tableName="core_config";
						$oldDb->addMissingEntries($missingEntryList, $tablePrefix, $tableName);
						$missingEntryList=$oldDbMissingList['lang'];
						$tableName="core_language";
						$oldDb->addMissingEntries($missingEntryList, $tablePrefix, $tableName);
						$missingEntryList=$oldDbMissingList['misc'];
						$tableName="core_misc_data";
						$oldDb->addMissingEntries($missingEntryList, $tablePrefix, $tableName);
					}
	
				} catch (Exception $e) {
					echo "Database user may not have access right to database ",$updater->oldDbName;
					echo "<br>";
				}

			}
			else{
				$form->setErrorMessages();

			}

		}

		return array(
			'newTableList' => $newTableList,
			'difItemList' => $difItemList,
			'pgStatus' => $pgStatus,
			'oldDbMissingList' => $oldDbMissingList,
			'form' => $form,
		);

	}

	public function updateDifferentEntriesEvent()
	{

		$form = new UpdaterForm();
		$form->setUrl($GLOBALS['curUrl']);
		$form->formMap['submit1']['value']="Find different entries";
		$form->formMap['submit2']['value']="Add different entries";

		$updater = new Updater();
		$pgStatus="stage1";

		$defCheckedStatus="";

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$newTableList=array();
		$oldTableList=array();
		$difItemList=array();

		$allDifList=array();
		$chDifList=array();
		$otherDifList=array();
		$oldDbMissingList=array();

		if (isset($_POST['submit1']) || isset($_POST['submit2'])) {

			$form->updateForm();
			$form->validation($appDb->getValidityPatterns($GLOBALS['modName']),array());

			if ($form->isValid) {

				if (isset($_POST['submit1'])) {
					$pgStatus="stage2";
				}
				elseif (isset($_POST['submit2'])) {
					$pgStatus="stage3";
				}
	
				$formData=$form->getData();
				$updater->convertFormData($formData);

				$newDbAccessData=$Database['app_db'];
				$newDbAccessData['dbName']=$updater->newDbName;
				$newDbAccessData['tablePrefix']=$updater->newDbTbPrefix;
				$oldDbAccessData=$Database['app_db'];
				$oldDbAccessData['dbName']=$updater->oldDbName;
				$oldDbAccessData['tablePrefix']=$updater->oldDbTbPrefix;
	
				try {
					$newDb = new AppDatabase($newDbAccessData);
					$wholeFldList=array("module_name","description","uri","type","value");
					$inputFldList=array("module_name","uri","type");
					$tbName="core_config";
					$newDbEntryList['config']=$newDb->getListOfEntries($updater->newDbTbPrefix,$tbName,$inputFldList);
	
					$tbName="core_language";
					$wholeFldList=array("language_code","type","module_name","specific_name","uri","text");
					$inputFldList=array("module_name","uri","type","specific_name","language_code");
					$newDbEntryList['lang']=$newDb->getListOfEntries($updater->newDbTbPrefix,$tbName,$inputFldList);
	
					$tbName="core_misc_data";
					$wholeFldList=array("integer_value","module_name","uri","type","value");
					$inputFldList=array("module_name","uri","type");
					$newDbEntryList['misc']=$newDb->getListOfEntries($updater->newDbTbPrefix,$tbName,$inputFldList);
/*
					$newDbEntryList['config']=$newDb->getSimpleList($updater->newDbTbPrefix,$tbName);
					$newDbEntryList['lang']=$newDb->getSimpleList($updater->newDbTbPrefix,$tbName);
					$newDbEntryList['misc']=$newDb->getSimpleList($updater->newDbTbPrefix,$tbName);
*/
				} catch (Exception $e) {
					echo "Database user may not have access right to database ",$updater->newDbName;
					echo "<br>";
				}
/*
//$fldList=$newDbEntryList['config']['fieldSet'];
$fldList=$newDbEntryList['config'];
				for ($i=0;$i<count($fldList);$i++) {
					print_r($fldList[$i]);
					echo "<br>";
					echo "<br>";

				}

*/
/*
				for ($i=0;$i<count($fldList);$i++) {
					$fldRow=$fldList[$i]['fieldSet'];

					for ($j=0;$j<count($fldRow);$j++) {
					}

				}
*/
				try {
					$oldDb = new AppDatabase($oldDbAccessData);

					$tbName="core_config";
					$newList=$newDbEntryList['config'];
					$inputFldList=array("module_name","uri","type");
					$outputFldList=array("description","value");
					$difItemList['config']=$oldDb->getDifferentEntries($updater->oldDbTbPrefix,$tbName,$newList,$inputFldList,$outputFldList);
	
					$tbName="core_language";
					$newList=$newDbEntryList['lang'];
					$inputFldList=array("module_name","uri","type","specific_name","language_code");
					$outputFldList=array("text");
					$difItemList['lang']=$oldDb->getDifferentEntries($updater->oldDbTbPrefix,$tbName,$newList,$inputFldList,$outputFldList);
	
					$tbName="core_misc_data";
					$newList=$newDbEntryList['misc'];
					$inputFldList=array("module_name","uri","type");
					$outputFldList=array("integer_value","value");
					$difItemList['misc']=$oldDb->getDifferentEntries($updater->oldDbTbPrefix,$tbName,$newList,$inputFldList,$outputFldList);

					$form->setValue("submit2","Update different entries");

					if ($pgStatus=="stage3") {

						$oldDb->updateDifEntries($difItemList,$updater->oldDbTbPrefix,$tbName,$form);

//						$_SESSION[($GLOBALS['siteId'])]['messageList'][]="<div class=\"success-note\">".$GLOBALS['localLang']['other']['submitMessage']."</div>";
	
						$redirectUrl="".$GLOBALS['baseUrl']."/".$GLOBALS['modPath']."/update-different-entries";
						$this->redirect($redirectUrl, false);

/*
						$tablePrefix=$updater->oldDbTbPrefix;
	
						$missingEntryList=$oldDbMissingList['config'];
						$tableName="core_config";
						$oldDb->addMissingEntries($missingEntryList, $tablePrefix, $tableName);
						$missingEntryList=$oldDbMissingList['lang'];
						$tableName="core_language";
						$oldDb->addMissingEntries($missingEntryList, $tablePrefix, $tableName);
						$missingEntryList=$oldDbMissingList['misc'];
						$tableName="core_misc_data";
						$oldDb->addMissingEntries($missingEntryList, $tablePrefix, $tableName);
*/
					}
	
				} catch (Exception $e) {
					echo "Database user may not have access right to database ",$updater->oldDbName;
					echo "<br>";
//					echo $e;
//					echo "<br>";
				}

			}
			else{
				$form->setErrorMessages();

			}

		}
//echo "pgStatus=";
//echo $pgStatus;
//echo "<br>";
		$checkboxScript=$updater->getTableScript();
//		$GLOBALS['headTags']=$GLOBALS['headTags'].$checkboxScript;

		return array(
			'newTableList' => $newTableList,
			'difItemList' => $difItemList,
			'pgStatus' => $pgStatus,
//			'oldDbMissingList' => $oldDbMissingList,
			'form' => $form,
			'cbScript' => $checkboxScript,
			'defCheckedStatus' => $defCheckedStatus,
		);

	}

}
