<?php

class AppDatabase extends DatabaseCms
{

	public $tablePrefix;

	public function __construct($dbData)
	{
		$this->dbId = new PDO('mysql:host=localhost;dbname='.$dbData['dbName'].';charset=utf8', $dbData['userName'], $dbData['userPassword']);
		$this->tablePrefix=$dbData['tablePrefix'];
		$this->dbId->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	}

	public function getListOfTables($dbName, $dbTbPrefix)
	{

		$tableList=array();

		$sqlString="SHOW TABLES from ".$dbName;
		$result = $this->dbId->query($sqlString);
		
		while ($row = $result->fetch(PDO::FETCH_NUM)) {
			$tbNetName=str_replace($dbTbPrefix,"",$row[0]);
//			echo $row[0]."<br>";
		$tableList[]=$tbNetName;
//			echo $tbNetName."<br>";
		}
		return $tableList;

	}

	public function getListOfEntries($dbTbPrefix, $tbName, $inputFldList)
	{

		$itemList=array();

		$multipleEntries=0;

		$sqlString="SELECT *";
		$sqlString.=" FROM ".$dbTbPrefix.$tbName;

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute();
		$resultSet = $stmt->fetchAll();

		foreach ($resultSet as $row) {

			$fieldString="";
			$whereClause="";
			$whereClause.=" WHERE ";
			for ($i=0;$i<count($inputFldList);$i++) {
				if($i>0)
					$whereClause.=" AND ";
				$whereClause.=$inputFldList[$i]." = '";
				$whereClause.=$row[($inputFldList[$i])];
				$whereClause.="'";

				$fieldString.=$inputFldList[$i]." = ";
				$fieldString.=$row[($inputFldList[$i])];
				$fieldString.="; ";

			}
			$dataSet['fieldSet'] = $row;
			$dataSet['whereClause'] = $whereClause;
			$dataSet['keySet'] = $fieldString;
			$itemList[] = $dataSet;

//Find entries from new table, which are occurring more than once
			$sqlString="SELECT *";
			$sqlString.=" FROM ".$dbTbPrefix.$tbName;
			$sqlString.=$whereClause;

			$stmt = $this->dbId->prepare($sqlString);
			$stmt->execute();
			$resultSet2 = $stmt->fetchAll();
		
//Find entries from new table, which are occurring more than once
			if(count($resultSet2)>1){
				$multipleEntries++;
				$multiGroup=array();
				foreach ($resultSet2 as $multiEntry) {
					$multiGroup[]=$multiEntry;
				}
				$multiItem['tbName']=$tbName;
				$multiItem['entrySet']=$multiGroup;
				$multiItem['keyFields']=$inputFldList;
				$GLOBALS['newMultipleEntries'][]=$multiItem;
			}

		}

		return $itemList;

	}

	public function getSimpleList($dbTbPrefix, $tbName)
	{

		$itemList=array();

		$sqlString="SELECT *";
		$sqlString.=" FROM ".$dbTbPrefix.$tbName;

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute();
		$resultSet = $stmt->fetchAll();

		foreach ($resultSet as $row) {
			$itemList[] = $row;
		}

		return $itemList;

	}

	public function getMissingEntries($dbTbPrefix, $tbName,$newList,$inputFldList,$outputFldList)
	{

		$itemList=array();

		$fldList = array_merge($inputFldList, $outputFldList);

		foreach ($newList as $row) {

			$sqlString="SELECT *";
			$sqlString.=" FROM ".$dbTbPrefix.$tbName;
			$sqlString.=$row['whereClause'];
			$sqlString.=" LIMIT 1";

//		echo "sqlString=";
//		echo $sqlString;
//		echo "<br>";
	
			$stmt = $this->dbId->prepare($sqlString);
			$stmt->execute();
			$resultSet = $stmt->fetchAll();


			if(count($resultSet)==0){
				$fieldString="";
				$valueString="";
				$prepArr=array();

				for ($i=0;$i<count($fldList);$i++) {

					if($i>0){
						$fieldString.=", ";
						$valueString.=", ";
					}
					$fieldString.=($fldList[$i]);
					$valueString.=(":".$fldList[$i]);
					$prepArr[(":".$fldList[$i])]=$row['fieldSet'][($fldList[$i])];
				}

				$item['fields']=$fieldString;
				$item['values']=$valueString;
				$item['prepared']=$prepArr;
				$item['rawData']=$row;
				$itemList[] = $item;
			}

		}

		return $itemList;

	}

	public function getDifferentEntries($dbTbPrefix, $tbName, $newList, $inputFldList, $outputFldList)
	{

		$difList=array();

		$multipleEntries=0;
		$noEntries=0;
		$difEntries=0;
		$countDif=0;

		foreach ($newList as $row) {

			$sqlString="SELECT *";
			$sqlString.=" FROM ".$dbTbPrefix.$tbName;
			$sqlString.=$row['whereClause'];

			$stmt = $this->dbId->prepare($sqlString);
			$stmt->execute();
			$resultSet = $stmt->fetchAll();

//Find entries from old table, which are occurring more than once
			if(count($resultSet)>1){
				$multipleEntries++;
				$multiGroup=array();
				foreach ($resultSet as $multiEntry) {
					$multiGroup[]=$multiEntry;
				}
				$multiItem['tbName']=$tbName;
				$multiItem['entrySet']=$multiGroup;
				$multiItem['keyFields']=$inputFldList;
				$GLOBALS['oldMultipleEntries'][]=$multiItem;
			}

//			if(count($resultSet)>1){
			if(count($resultSet)==0){
				$noEntries++;
			}

			foreach ($resultSet as $oldResRow) {
	
				$setData="";
				$difData="";
	
				for ($i=0;$i<count($outputFldList);$i++) {
	
					$newRow=$row['fieldSet'];
					$ind=$outputFldList[$i];
					$oldRow=$oldResRow;

					if($newRow[($ind)]!=$oldRow[($ind)]){
	
						if($i!=0)
							$setData.=",";
	
						if($ind!="integer_value")
							$setData.=$outputFldList[$i]."="."'".$newRow[($ind)]."'";
						else
							$setData.=$outputFldList[$i]."=".$newRow[($ind)];
	
							$difData['keySet']=$row['keySet'];
							$difData['whereClause']=$row['whereClause'];
							$difData['setClause']=$setData;
							$difData['id']=$oldResRow['id'];
							$difData['table']=$tbName;
							$difData['prefix']=$tbName;
							$difData['difFieldName']=$outputFldList[$i];
//							$difData['id']=$row['fieldSet']['id'];
							
							$countDif++;
	
							$difData['oldVal']=$oldRow[($ind)];
							$difData['newVal']=$newRow[($ind)];
							
							$difList[]=$difData;
	
					}
	
				}
	
			}
	
		}
/*
echo "Number of entries, which are missing in old table:";
echo $noEntries;
echo "<br>";
echo "Use other method to add them to old table before updating the differences!";
echo "<br>";
*/
		return $difList;

	}


	public function updateDifEntry($difEntryDetails, $tablePrefix, $tableName){

//Query approach to show whole sql string for easier testing on phpMyadmin 
/*
		$sqlString="UPDATE ".$tablePrefix.$tableName;
		$sqlString.=" SET ";

		if($difEntryDetails['difFieldName']=="integer_value"){
			$sqlString.=($difEntryDetails['difFieldName']." = ");
			$sqlString.=$difEntryDetails['newVal'];
		}else{
			$sqlString.=($difEntryDetails['difFieldName']." = '");
			$sqlString.=$difEntryDetails['newVal'];
			$sqlString.="'";
		}

		$sqlString.=(" WHERE id = ".$difEntryDetails['id']);
		$entryArr=array();
*/
/*
		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute($entryArr);
*/

//Query approach to avoid possible quote issues
		$sqlString="UPDATE ".$tablePrefix.$tableName;
		$sqlString.=" SET ";

		$sqlString.=($difEntryDetails['difFieldName']." = ");
		$sqlString.=":udValue";

		$sqlString.=(" WHERE id = :id");
//		echo "sqlString=";
//		echo $sqlString;
//		echo "<br>";

		$entryArr[':udValue']=$difEntryDetails['newVal'];
		$entryArr[':id']=$difEntryDetails['id'];

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":udValue" => $difEntryDetails['newVal'],
			":id" => $difEntryDetails['id']
		));


//		echo "print_r(entryArr)=";
//		print_r($entryArr);
//		echo "<br>";


	}

	public function updateDifEntries($difItemList, $tablePrefix, $tableName, $form)
	{

//		echo "Update diff. entries";
//				echo "<br>";

		if(isset($_POST['contentCb']))
			$checkedValues=$_POST['contentCb'];
/*
		echo "print_r(checkedValues)=";
		print_r($checkedValues);
		echo "<br>";
		echo "<br>";
*/

		$cbInd=0;
		$tableName="core_config";
		foreach ($difItemList['config'] as $difEntryDetails) {
			if(in_array($cbInd,$checkedValues)){
				$this->updateDifEntry($difEntryDetails, $tablePrefix, $tableName);
			}
			$cbInd++;
		}

		$tableName="core_language";
		foreach ($difItemList['lang'] as $difEntryDetails) {
			if(in_array($cbInd,$checkedValues)){
				$this->updateDifEntry($difEntryDetails, $tablePrefix, $tableName);
			}
			$cbInd++;
		}

		$tableName="core_misc_data";
		foreach ($difItemList['misc'] as $difEntryDetails) {
			if(in_array($cbInd,$checkedValues)){
				$this->updateDifEntry($difEntryDetails, $tablePrefix, $tableName);
			}
			$cbInd++;
		}

	}


	public function addMissingEntries($missingEntryList, $tablePrefix, $tableName)
	{

		$id=0;


		foreach ($missingEntryList as $row) {

			$sqlString="INSERT INTO ".$tablePrefix.$tableName." (".$row['fields'].")";
			$sqlString.=" VALUES (".$row['values'].")";

			$stmt = $this->dbId->prepare($sqlString);
			$stmt->execute($row['prepared']);

		}

	}


	public function getTableStruct($dbTbPrefix, $tbName)
	{

		$structList=array();

		$tableToDescribe=$dbTbPrefix.$tbName;

		$statement = $this->dbId->query('DESCRIBE ' . $tableToDescribe);

		$result = $statement->fetchAll(PDO::FETCH_ASSOC);
 
		foreach($result as $row){
			$structList[]=$row;
		}

		return $structList;

	}


	public function changeStructure($newDbStruct, $oldDbStruct, $tablePrefix, $tableName)
	{

		$nullString="";
		if($newDbStruct['Null']=="NO")
			$nullString="NOT NULL";
		else
			$nullString="NULL";

		$defaultString="";

		if (!strstr($newDbStruct['Field'],"id"))
			$defaultString=" DEFAULT '".$newDbStruct['Default']."'";

		$sqlString="";
		$sqlString.="ALTER TABLE ".$tablePrefix.$tableName." CHANGE COLUMN ".$oldDbStruct['Field']." ".$newDbStruct['Field']." ".$newDbStruct['Type']." NOT NULL".$defaultString.";";

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
		));

	}

}
